---------------------------------------------------------------------------------------
-------------------------------------- 2021.07.22 -------------------------------------
--[[
___.echo(chaine [, nomCouleur, nomChat]) -- 1ere fenetre de chat si non spécifiée
___.echoChatAppl(chaine, showVersionBooleen, colorNameOrHexa) -- echo avec nom et version addon

___.getTxtColor(chaine [, colorNameOrHexa]) -- renvoit la chaine formattée avec la couleur ("SYSTEM" par défaut)

___.testPrint(chaine) -- echo seulement si mode DEBUG activé (nécessite addonVar et getVar() !

___.echoTable(tbl [, comm, niveauUnique, prefixe, nivIndent]) -- pour DEV
___.echoDebug(valeur [, comm]) -- pour DEV

___.getColor(colornameOrHexaOrRGBtable, outputFormatStr)
	-- convertit la couleur passée au format de sortie voulu : "hexa" || "table" || "rgb" (defaut)
	-- colornameOrHexaOrRGBtable : nom couleur (chaine), ou couleur hexa (chaine), ou table {r,g,b}
--]]

---------------------------------------------------------------------------------------
---------------------------------------- DIVERS ---------------------------------------

function Emlib.valSiNul(value, defaultValue)
	local defaultValue = defaultValue or "NIL"
	if (value == nil) then return defaultValue else return value end
end

function Emlib.videSiNul(valeur)
	if (valeur == nil) then return "" else return valeur end
end

function Emlib.nilSiNul(valeur)
	if (valeur == nil) then return "NIL" else return valeur end
end

function Emlib.zeroSiNul(value, numberOnly) -- avec numberOnly à true : renvoit 0 si value n'est pas un nombre
	if (numberOnly == nil) then numberOnly = false end
	if (value == nil) then
		return 0
	else
		if (numberOnly == true) then
			if (tonumber(value) == nil) then
				return 0
			else
				return tonumber(value)
			end
		else
			return value
		end
	end
end

function Emlib.isEmpty(variable) -- renvoit true si la variable ou la table passee est vide ou nil
	if (type(variable) == "table") then
		local next = next;
		return (next(variable) == nil);
	else
		return (variable == nil or variable == "");
	end;
end

function Emlib.isTrue(value, acceptYes) -- accepte les entiers 0 et 1, et aussi les chaines avec "acceptYes" à TRUE
	if (value ~= nil) then
		if (type(value) == "boolean") then
			return value
		else
			local tbl = {1, "1", "true"}
			if (acceptYes == true) then tbl = {1, "1", "true", "y", "yes", "on"} end
			return (tContains(tbl, string.lower(tostring(value))))
		end
	else
		return false
	end
end

function Emlib.attribueBinaire(valeur)
	if (valeur == 1 or valeur == "1") then return (1); else return (0) end
end

function Emlib.getBindedKey(nomCommande)
	----- renvoit le NOM de la touche associee a la commande passee : non encore disponible sur VARIABLE_LOADED !
	----- renvoit NIL s'il n'y a pas de touche associee a la commande passee (chaine entre guillemets)
	if (type(nomCommande) == "string") then
		local key1,key2 = GetBindingKey(nomCommande)
		if (key1 == nil and key2 == nil) then return nil end
		if (key1 ~= nil) then return key1 else return key2 end
	else
		return "ERROR"
	end
end

function Emlib.testPrint(str) -- nécessite addonVar et getVar() !
	if (Emlib.debug()) then print(Emlib.getTxtColor(Emlib.getVar("name").." @ "..Emlib.getHorodatage().." ", "red")..Emlib.getTxtColor(Emlib.nilSiNul(str), "orange")) end
end

function Emlib.getSeconds(msBoolean) -- serverTime en seconds. si msBoolean true :  renvoit les ms en décimales
	local now = GetServerTime()
	if (Emlib.isTrue(msBoolean)) then
		return (now + math.fmod(GetTime(), 1))
	else
		return now
	end
end

function Emlib.getHorodatage(fullDateBoolean) -- formatage de l'horodatage
	if (Emlib.isTrue(fullDateBoolean)) then
		return date("%Y.%m.%d %H:%M:%S", GetServerTime())
	else
		return date("%H:%M:%S", GetServerTime())
	end
end

function Emlib.getApplName(showVersionBooleen) -- nécessite addonVar et getVar() !
	local strTemp = Emlib.getVar("name") or "???"
	if (Emlib.isTrue(showVersionBooleen)) then strTemp = strTemp.." "..Emlib.getVersion(false) end
	return "|cFF".. Emlib.getVar("chatColor")..strTemp.."|r"
end

function Emlib.getVersion(numberFormatBoolean) -- nécessite addonVar et getVar() !
	-- avec numberFormatBooleen TRUE : renvoit la valeur numérique de la version
	-- avec numberFormatBooleen FALSE : renvoit une chaine et le tag "X-PublicVersion"
	if (Emlib.isTrue(numberFormatBooleen)) then
		return Emlib.strToNumber(Emlib.getVar("version"))
	else
		local publicVersion
		publicVersion = Emlib.videSiNul(GetAddOnMetadata(Emlib.getVar("name"), "X-PublicVersion"))
		return (Emlib.getVar("version")..publicVersion)
	end
end

function Emlib.getStuffPath(elementName, inStuffFolderBoolean) -- nécessite addonVar et getVar() !
	local path = "Interface\\AddOns\\"..Emlib.getVar("name").."\\"
	if (Emlib.isTrue(inStuffFolderBoolean)) then path = path.."stuff\\" end
	return path..elementName
end

function Emlib.echoChatAppl(str, showVersionBooleen, color)
	-- affiche la str dans la 1ere fenetre de chat VISIBLE avec le nom (et éventuellement la version) de l'addon
	-- color : tout type de couleur accepeté ("SYSTEM" par défaut)
	local strTemp = Emlib.getApplName(showVersionBooleen)
	Emlib.echoWindow(strTemp.." "..Emlib.getTxtColor(str, color), nil, nil)
end

function Emlib.isWoW() -- renvoit true si WoW "normal"
	return (WOW_PROJECT_ID == 1) -- WOW_PROJECT_CLASSIC ou WOW_PROJECT_BURNING_CRUSADE_CLASSIC
end

function Emlib.isClassic() -- renvoit true si Classic (gardé pour rétro-compatibilité)
	return (WOW_PROJECT_ID == WOW_PROJECT_CLASSIC)
end

function Emlib.wowMasterVersion() -- renvoit le numéro générique de vesrion de WoW (8 pour BFA, 9 pour SL)
	local wowversion, wowbuild, wowdate, wowtocversion = GetBuildInfo()
	return floor(wowtocversion / 10000)
end

function Emlib.executeCmd(cmdStr, isMacroBoolean, noPrintErrorBoolean) -- return "", or error string
	-- execute une /macro ou commande (plusieurs lignes possible)
	local cmdStr = cmdStr or ""
	local tbl = {strsplit("\n", cmdStr)}
	
	local function executeString(str) -- return "", or error string
		local str = str or ""
		local func, errorMessage = loadstring(str)
		if (not func) then
			return "slash command LUA error #59000."
		else
			local success, errorMessage = pcall(func)
			if (not success) then
				return "slash command error #59001."
			else
				return ""
			end
		end
	end
	
	local resultStr = ""
	for i, strLine in ipairs(tbl) do
		if (resultStr ~= "") then break end
		if (Emlib.isTrue(isMacroBoolean)) then
			--------------------------- macro ("/" needed)
			if (string.sub(strLine, 1, 1) ~= "/") then strLine = "/"..strLine end
			if (string.sub(strLine, 1, 5) == "/run ") then
				strLine = string.sub(strLine, 6)
				resultStr = executeString(strLine)
			elseif (string.sub(strLine, 1, 8) == "/script ") then
				strLine = string.sub(strLine, 9)
				resultStr = executeString(strLine)
			else
				DEFAULT_CHAT_FRAME.editBox:SetText(strLine) -- sent to Chat Box
				ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox,0)
			end
		else
			--------------------------- command ("/" not valid)
			if (string.sub(strLine, 1, 1) == "/") then strLine = string.sub(strLine, 2) end -- delete char 1
			resultStr = executeString(strLine)
		end
	end
	
	if ((resultStr ~= "") and (not noPrintErrorBoolean)) then Emlib.echoChatAppl(resultStr, false, "red") end
	return resultStr
end

function Emlib.executeMacro(macroStr) -- conservé pour rétro-compatibilité
	Emlib.executeCmd(macroStr, true)
end

function Emlib.invertColor(color)
	-- renvoit sous forme r,g,b les valeurs inversées de la couleur passée (toutes formes acceptées)
	local r, g, b = Emlib.getColor(color, "rgb")
	---------------
	if ((r > 0.4 and r < 0.6) and (g > 0.4 and g < 0.6) and (b > 0.4 and b < 0.6)) then -- gris moyen
		return 0.86, 0.84, 0.49 -- jaune pale
	else
		return Emlib.inversionValeur(r), Emlib.inversionValeur(g), Emlib.inversionValeur(b)
	end
end

function Emlib.flash(texture, delay, alpha) -- effet visuel
	local delay = tonumber(delay) or 0.3 -- seconde
	
	local savedAlpha = texture:GetAlpha()
	local alpha = tonumber(alpha) or Emlib.inversionValeur(savedAlpha)
	texture:SetAlpha(alpha)
	C_Timer.After(delay, function()
		texture:SetAlpha(savedAlpha)
	end)
end

---------------------------------------------------------------------------------------
-------------------------------------- CONVERSION -------------------------------------

function Emlib.strToNumber(chaine) -- renvoit 0 par defaut, alors que tonumber() renvoit nil
	local valTmp = tonumber(chaine, 10)
	if (valTmp == nil) then return 0 else return valTmp end
end

function Emlib.booleanToBin(boolean)
	return (boolean == 1)
end

function Emlib.booleanToInt(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return 1 else return 0 end
end

function Emlib.booleanToStr(boolean)
	local boolean = boolean or false
	return tostring(boolean)
end

function Emlib.booleanToEN(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return "YES" else return "NO" end
end

function Emlib.booleanToON(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return "ON" else return "OFF" end
end

---------------------------------------------------------------------------------------
------------------------------------- ARITHMETIQUE ------------------------------------

function Emlib.inversionValeur(valeur)
	return math.abs(valeur - 1)
end

function Emlib.round(number, numDecimalPlaces, toStringBoolean)
	local number = number or 0
	local numDecimalPlaces = numDecimalPlaces or 0
	if (Emlib.isTrue(toStringBoolean)) then
		return (string.format("%."..numDecimalPlaces.."f", number)) -- résultat en string
	else
		return tonumber(string.format("%."..numDecimalPlaces.."f", number)) -- résultat en nombre
	end
end

function Emlib.arrondi(valeur, nbreDecimales) -- pour rétro-compatibilité
	return Emlib.round(valeur, nbreDecimales, false)
end

function Emlib.nombreCompris(nombre, borneInf, borneSup)
	local valeur = tonumber(nombre);
	if (valeur ~= nil) then
		valeur = max(borneInf,valeur);
		valeur = min(borneSup,valeur);
	else
		valeur = borneInf;
	end;
	return valeur;
end

function Emlib.nombreParDefaut(nombre, defautVal, borneInf, borneSup) -- bornes optionnelles
	local valeur = tonumber(nombre)
	if (valeur == nil) then return defautVal end
	if (borneInf ~= nil and valeur < borneInf) then return defautVal end
	if (borneSup ~= nil and valeur > borneSup) then return defautVal end
	return valeur;
end

function Emlib.entierParDefaut(nombre, defautVal) -- entier !!!
	if (defautVal == nil) then defautVal = 0 end
	nombre = tonumber(nombre)
	if (nombre == nil) then return defautVal else return floor(nombre) end
end

---------------------------------------------------------------------------------------
--------------------------------------- CHAINES ---------------------------------------

function Emlib.kwote(chaine)
	return ("\""..Emlib.videSiNul(chaine).."\"")
end

function Emlib.simpleKwote(chaine) -- guillemets simples
	return ("'"..Emlib.videSiNul(chaine).."'")
end

function Emlib.truncStr(str, maxChars, strReplaceCR) -- si strReplaceCR = nil : pas de remplacement de CR
	local str = str or ""
	local maxChars = tonumber(maxChars) or 0
	if (strReplaceCR ~= nil) then str = string.gsub(str, "\n", strReplaceCR) end
	if (string.len(str) > maxChars) then return (string.sub(str, 0, maxChars - 1).."…") else return str end
end

function Emlib.getItem(chaine, delim, numeroItem)
	-- renvoit l' "élément" de la chaine passée, séparé par delim (avec la numérotation "littéraire")
	-- renvoit la chaine entière si pas de delim dans la chaine
	-- numeroItem : accepte les chaines '1, first, premier, last, dernier' (premier item par défaut)
	
	if (chaine == nil) then return "" end
	local numeroItem = numeroItem or 1
	local delim = delim or " "
	
	local tbl = {strsplit(delim, chaine, 0)} -- no limit
	local tailleTbl = #(tbl)
	if (tailleTbl > 1) then
		if (numeroItem == '1' or numeroItem == 'first' or numeroItem == 'premier') then
			numeroItem = 1
		elseif (numeroItem == 'last' or numeroItem == 'dernier') then
			numeroItem = tailleTbl
		else
			numeroItem = tonumber(numeroItem) or 1
		end
		return tbl[min(tailleTbl, max(1, numeroItem))]
	else
		return chaine
	end
end

function Emlib.getLastItem(chaine, delim) -- raccourci pour .getItem()
	-- renvoit le dernier "élément" de la chaine passée, séparé par delim (ou la chaine entière si pas de delim dans la chaine)
	return Emlib.getItem(chaine, delim, 'last')
end

function Emlib.explode(str, delim, maxItems) -- conservé pour rétro-compatibilité
	-- si maxItems = 0 ou nil, la fcn renverra la table complete
	if (str == nil) then return {} end
	local maxItems = tonumber(maxItems) -- nil possible
	local delim = delim or ","
	
	return {strsplit(delim, str, maxItems)} -- table
end

function Emlib.implode(tbl, delim) -- identique a la fcn de PHP (renvoit une chaine)
	if (type(tbl) == "table") then
		if (not Emlib.isEmpty(tbl)) then
			if (delim == nil) then delim = ""; end;
			local tailleDelim = strlen(delim);
			local chaine = "";
			for index, value in pairs(tbl) do
				chaine = chaine..value..delim;
			end;
			tbl = string.sub(chaine, 1, -(tailleDelim + 1)); -- suppression dernier delim
		end;
	end;
	return tbl;
end

---------------------------------------------------------------------------------------
---------------------------------------- TABLES ---------------------------------------

function Emlib.sortTable(tableOr, cle, sens, genre) -- ATTENTION : à utilser comme fcn (ne modifie pas l'original)
	----- trie la table passee par une cle
	----- sens peut etre "A" (ascendant, defaut) ou "D" (descendant)
	----- genre peut etre "N" (numerique, defaut) ou "A" (alphabetique)
	local sens = sens or "A"
	sens = string.upper(string.sub(sens,1,1))
	local genre = genre or "N"
	genre = string.upper(string.sub(genre,1,1))
	
	local tbl = {}
	for i in ipairs(tableOr) do
		table.insert(tbl, i)
	end
	
	if (sens == "D") then
		if (genre == "A") then
			table.sort(tbl, function(a, b) return string.lower(tableOr[a][cle]) > string.lower(tableOr[b][cle]) end)
		else -- numerique par defaut
			table.sort(tbl, function(a, b) return tableOr[a][cle] > tableOr[b][cle] end)
		end
	else -- ascendant par defaut
		if (genre == "A") then
			table.sort(tbl, function(a, b) return string.lower(tableOr[a][cle]) < string.lower(tableOr[b][cle]) end)
		else -- numerique par defaut
			table.sort(tbl, function(a, b) return tableOr[a][cle] < tableOr[b][cle] end)
		end
	end
	
	for i in ipairs(tbl) do
		tbl[i] = tableOr[tbl[i]]
	end
	
	return tbl
end

function Emlib.copyTable(tbl, metaIdentique)
	----- effectue une vraie copie d'une table et non un clonage
	----- si metaIdentique vaut TRUE, les 2 tables partageront la meme metatable
	
	local lookup_table = {}
	local function copyTableRec(tbl)
		if type(tbl) ~= "table" then
			return tbl
		elseif lookup_table[tbl] then
			return lookup_table[tbl]
		end
		local new_table = {}
		lookup_table[tbl] = new_table
		for index, value in pairs(tbl) do
			new_table[copyTableRec(index)] = copyTableRec(value)
		end
		
		if (metaIdentique) then
			return setmetatable(new_table, getmetatable(tbl))
		else
			return setmetatable(new_table, copyTableRec(getmetatable(tbl)))
		end;
	end
	return copyTableRec(tbl)
end

function Emlib.isInTable(tbl, valeur, caseNonSensitive)
	----- renvoit la cle (numerique ou associative) de la table passée dont l'element vaut la valeur passee
	----- renvoit NIL si aucun element ne vaut la valeur passee
	----- identique à tcontains() mais fonctionne aussi pour une table associative
	if (caseNonSensitive) then
		for key, value in pairs(tbl) do
			if (strlower(value) == strlower(valeur)) then return key; end;
		end;
	else
		for key, value in pairs(tbl) do
			if (value == valeur) then return key; end;
		end;
	end;
	return nil;
end

function Emlib.tableKeyDiff(tblReference, tblToCheck, level) -- renvoit nil si les deux tables possèdent les mêmes clés (attention à l'ordre des params !)
	local level = level or ""
	if (type(tblReference) == "table" and type(tblToCheck) == "table") then
		for key, value in pairs(tblReference) do
			if (tblToCheck[key] == nil) then return level.."."..key end
			if (type(value) == "table") then
				local w = Emlib.tableKeyDiff(value, tblToCheck[key], key)
				if (w ~= nil) then return level.."."..w end
			end
		end
	else
		return "not a table"
	end
end

function Emlib.getEnd(tbl) -- renvoit le dernier élément d'une table , ou nil
	if (tbl == nil or type(tbl) ~= "table") then return nil else return tbl[#tbl] end
end

---------------------------------------------------------------------------------------
-------------------------------- CONVERSIONS COULEURS ---------------------------------

function Emlib.getColor(colornameOrHexaOrRGBtable, outputFormatStr)
	-- convertit la couleur passée au format de sortie voulu : outputFormatStr = "hexa" || "table" || "rgb" (defaut)
	-- colornameOrHexaOrRGBtable : nom couleur (chaine), ou couleur hexa (chaine), ou table {r,g,b}
	
	local outputFormatStr = outputFormatStr or "rgb"
	outputFormatStr = strlower(outputFormatStr)
	local r, g, b = 0.5, 0.5, 0.5 -- default
	local arg = colornameOrHexaOrRGBtable or {r, g, b}
	
	---------------------------------------------- définition couleur passée
	if (type(arg) == "table") then
		------------------------------ table {r,g,b} passée
		if (#(arg) >= 3) then r, g, b = arg[1], arg[2], arg[3] end
	elseif (type(arg) == "string") then
		------------------------------ chaine passée
		local tableColor = Emlib.getPredefinedColor(arg, true) -- retour sous forme de table
		if (tableColor ~= nil) then
			------------- chaine passée = nom couleur prédéfini
			r, g, b = tableColor[1], tableColor[2], tableColor[3]
		else
			------------- chaine passée est une couleur en hexa valide ?
			r, g, b = Emlib.HexToRGBPerc(arg)
			if (r == nil) then
				r, g, b = 0.5, 0.5, 0.5 -- chaine passée non hexa valide : retour au défaut
			end
		end
	end
	
	---------------------------------------------- retour
	if (outputFormatStr == "hexa") then
		return Emlib.RGBPercToHex(r, g, b)
	elseif (outputFormatStr == "table") then
		return {r, g, b}
	else
		return  r, g, b
	end
end

function Emlib.colornameToHexa(colorNameOrHexa) -- convertit la couleur passée en forme hexa (6 digits)
	-- colorNameOrHexa peut etre un nom de couleur prédéfinie, ou une chaine hexa (inchangée), ou nil ("SYSTEM" par défaut)
	------------------------------------ default : "SYSTEM"
	local tblChat = ChatTypeInfo["SYSTEM"]
	local sysColor = Emlib.RGBPercToHex(tblChat["r"], tblChat["g"], tblChat["b"])
	------------------------------------
	if (colorNameOrHexa == nil or colorNameOrHexa == "") then
		return sysColor
	else
		local hexaColor = Emlib.getPredefinedColor(colorNameOrHexa, false)
		if (hexaColor ~= nil) then
			---------------------------- nom couleur trouvée
			return hexaColor
		else
			---------------------------- chaine passée est une couleur en hexa valide ?
			local r, g, b = Emlib.HexToRGBPerc(colorNameOrHexa)
			if (r ~= nil) then return colorNameOrHexa end
		end
	end
	return sysColor -- defaut
end
function Emlib.getHexColor(colorNameOrHexa) -- pour rétro-compatibilité
	return Emlib.colornameToHexa(colorNameOrHexa)
end

function Emlib.RGBPercToHex(r, g, b) -- convertit les composantes couleurs passées en chaine hexa (ou nil)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

function Emlib.HexToRGBPerc(hexStr) -- convertit la couleur hexa passée (chaine) en décimal RGB (ou nil)
	local hexStr = hexStr or "CCCCCC"
	if (string.sub(hexStr, 1, 1) == "#") then hexStr = string.sub(hexStr, 2) end
	local rhex, ghex, bhex = string.sub(hexStr, 1, 2), string.sub(hexStr, 3, 4), string.sub(hexStr, 5, 6)
	if ((tonumber(rhex, 16) ~= nil) and (tonumber(ghex, 16) ~= nil) and (tonumber(bhex, 16) ~= nil)) then
		return (tonumber(rhex, 16)/255), (tonumber(ghex, 16)/255), (tonumber(bhex, 16)/255)
	else
		return nil, nil, nil
	end
end

function Emlib.getPredefinedColor(englishColorName, resultTableBoolean)
	-- renvoit la chaine hexa ou la table {r,g,b}, ou nil, d'une couleur prédéfinie
	-- accepte "system" comme nom de couleur (defaut)
	local englishColorName = englishColorName or "system"
	englishColorName = strlower(englishColorName)
	
	local tblChat = ChatTypeInfo["SYSTEM"]
	local tbl = {
		["red"] = {"CF5F1B", {0.81,0.37,0.11}},
		["orange"] = {"CBA934", {0.8,0.66,0.2}},
		["yellow"] = {"FFFF00", {1, 0.8, 0}},
		["green"] = {"4FC032", {0.31,0.75,0.2}},
		["aqua"] = {"55EBF7", {0.33,0.92,0.97}},
		["blue"] = {"8792F5", {0.41,0.41,0.98}},
		["purple"] = {"A84DF2", {0.66,0.3,0.95}},
		["white"] = {"FFFFFF", {1,1,1}},
		["cream"] = {"EDDEBF", {0.93,0.87,0.75}},
		["grey"] = {"AAAAAA", {0.67,0.67,0.67}},
		["gray"] = {"AAAAAA", {0.67,0.67,0.67}},
		["silver"] = {"D9D9D9", {0.85,0.85,0.85}},
		["dark"] = {"444444", {0.27,0.27,0.27}},
		["black"] = {"111111", {0.07,0.07,0.07}},
		["system"] = {Emlib.RGBPercToHex(tblChat["r"], tblChat["g"], tblChat["b"]), {tblChat["r"], tblChat["g"], tblChat["b"]}},
	}
	
	if (tbl[englishColorName] ~= nil) then
		---------------------------- nom couleur trouvée
		if (Emlib.isTrue(resultTableBoolean)) then return tbl[englishColorName][2] else return tbl[englishColorName][1] end
	else
		return nil
	end
end

function Emlib.getRGBColor(colorNameOrHexa)
	-- raccourci : renvoit les valeurs r, g, b d'une couleur passée sous forme de table
	local r, g, b = Emlib.HexToRGBPerc(Emlib.colornameToHexa(colorNameOrHexa))
	return {r, g, b}
end

---------------------------------------------------------------------------------------
--------------------------------------- GROUP (IG) ------------------------------------

function Emlib.inParty(noRaid) -- renvoit true si en "vrai" groupe (party OU raid)
	-- noRaid (true par défaut) permet de ne pas compter les groupes d'un raid
	if (Emlib.isEmpty(noRaid)) then noRaid = true end -- ne pas compter les groupes de raid
	
	if (noRaid) then
		return (IsInGroup(LE_PARTY_CATEGORY_HOME) and not IsInRaid()) -- filtre pour "vrai" groupe (non instance)
	else
		return IsInGroup(LE_PARTY_CATEGORY_HOME) -- filtre pour "vrai" groupe (non instance)
	end
end

function Emlib.inRaid() -- renvoit true si en raid seulement (pas en party ni instance)
	return (IsInRaid() and not Emlib.inInstance())
end

function Emlib.inInstance() -- renvoit true si en instance (LFG/LFR) : remplacement de Emlib.inInstance() dont les résultats ne sont pas fiables
	return IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
end

function Emlib.isGrouped(noInstance) -- renvoit true si groupé (raid OU party OU instance)
	-- noInstance (true par défaut) permet de ne pas compter les groupes d'instance
	if (Emlib.isEmpty(noInstance)) then noInstance = true end -- ne pas compter les instances
	
	if (noInstance) then
		return (GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) > 0) -- filtre instance actif
	else
		return (GetNumGroupMembers() > 0) -- raid, groupe et instance
	end
end

---------------------------------------------------------------------------------------
----------------------------------- SLASH-COMMANDES -----------------------------------

function Emlib.slashCmd_Lib(arg, execLevel)
	-- pour tester une commande : Emlib.slashCmd_Lib("commande slash telle que tapée dans chat")
	local execLevel = execLevel or 1 -- pour infinite loop
	local taille = 0
	local tblParams = {strsplit(" ", arg, 2)} -- 2 params maxi
	local passedCmd = tblParams[1] or nil
	
	local function slashCmd_subTableSearch(passedCmd, subTbl)
		for i, value in ipairs(subTbl) do
			if (tContains(value.cmd, passedCmd)) then return value end
		end
		return nil
	end
	
	local tblCmds = Emlib.slashCmd_getList(tblParams[2]) -- passer tblParams[2] pour exécuter fcn définie dans la liste des cmds
	if (not Emlib.isEmpty(passedCmd)) then
		passedCmd = strlower(passedCmd)
	else
		passedCmd = tblCmds.DEFAULTCMD
	end
--print("slashCmd_Lib() : passedCmd=", passedCmd, "---execLevel=", execLevel)--/////

	------------------------------------ recherche commande passée dans "macro", puis "user" et enfin "dev"
	local cmdTbl
	if (tblCmds["macro"] ~= nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.macro) end
	if (cmdTbl == nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.user) end
	if (cmdTbl == nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.dev) end
	
	if (cmdTbl == nil) then
		------------- commande non trouvée
		if (type(execLevel) ~= "number" or execLevel > 1) then
			Emlib.echoChatAppl("unknown command.", true, "red")
		else
--print("slashCmd_Lib() : DEFAULTCMD=", tblCmds.DEFAULTCMD)--/////
			Emlib.slashCmd_Lib(tblCmds.DEFAULTCMD, 2)
		end
	else
		cmdTbl.func(tblParams[2])
	end
end

function Emlib.slashCmd_showList(dontPrint) -- affichage de la liste des slash-commands : nécessite addonVar et getVar() !
	local tblCmds = Emlib.slashCmd_getList()
	local cmdInfos = {}
	
	local function formatLineCmd(tbl, comm)
		local comm = comm or ""
		local tbl = tbl or {}
		
		local addonCmd = Emlib.getVar("slashCmd")
		if (addonCmd == nil) then addonCmd = Emlib.videSiNul(Emlib.getVar("name")) end
		addonCmd = "/"..addonCmd.." "
		if (comm ~= "") then addonCmd = comm.."   "..addonCmd end
		
		addonCmd = addonCmd..tbl.cmd[1]
		if (not Emlib.isEmpty(tbl.type)) then addonCmd = addonCmd.." ["..tbl.type.."]" end
		if (not Emlib.isEmpty(tbl.label)) then addonCmd = addonCmd.." : "..tbl.label end

		return addonCmd
	end

	------------------------- construction avec cmds user
	for i, data in ipairs(tblCmds.user) do
		table.insert(cmdInfos, formatLineCmd(data, comm))
	end
	------------------------- ajout éventuel des cmds dev
	if (Emlib.debug()) then
		for i, data in ipairs(tblCmds.dev) do
			table.insert(cmdInfos, formatLineCmd(data, "DEV"))
		end
	end
	------------------------- sortie
	if (Emlib.isTrue(dontPrint)) then -- pour UI config (si existe)
		local helpStr = ""
		for index, value in ipairs(cmdInfos) do
			helpStr = helpStr..value.."\n"
		end
		return (string.sub(helpStr, 1, -2))
	else
		Emlib.echoChatAppl(Emlib.getLocal("Available commands:"), true, "grey")
		for key,value in pairs(cmdInfos) do
			Emlib.echoChat("      "..value.."", "SYSTEM", true)
		end
	end
end

---------------------------------------------------------------------------------------
------------------------------------------ XML ----------------------------------------

function Emlib.setEscapeClosable(frame) -- le frame doit avoir un nom !
	if (frame:GetName() ~= nil) then tinsert(UISpecialFrames, frame:GetName()) end
end

function Emlib.setTextInAutoFrame(frame, fontString, texte, bordureBoolean, padding)
	----- remplit la fontString du frame passé avec du texte, en dessinant eventuellement une bordure et ajuste la hauteur du frame cible
	----- sans bordure, le padding vaut 0, quelle que soit la valeur passée
	----- compatible Classic et SL(9.x)
	if (frame ~= nil and fontString ~= nil) then
		if (Emlib.isTrue(bordureBoolean)) then
			Emlib.setFramedFrame(frame, "tooltip")
			frame:SetBackdropBorderColor(0.5, 0.5, 0.5)
			frame:SetBackdropColor(0.3, 0.3, 0.3, 0.5)
		
			if (padding ~= nil) then padding = tonumber(padding) end
			if (padding == nil) then padding = 10 end
		else
			padding = 0
		end
		
		fontString:SetText(texte)
		fontString:SetPoint("TOPLEFT" ,frame, "TOPLEFT", padding, -padding)
		fontString:SetWidth(ceil(frame:GetWidth()) - (padding * 2))
		frame:SetHeight(fontString:GetHeight() + (padding * 2))
	end
end

function Emlib.createBorder(frame, borderWidth, borderColor, borderAlpha)
	-- dessine ou modifie une bordure autour du frame passé
	-- borderColor : nom couleur, ou couleur hexa, ou table {r, g, b}
	-- appel pour créer ou *modifier* une bordure existante : .createBorder(myFrame, 1, "blue", 0.8)
	-- pour supprimer une bordure existante : passer 0 en borderWidth
	
	local borderWidth = tonumber(borderWidth) or 0
	if (borderColor ~= nil) then
		local borderAlpha = tonumber(borderAlpha) or 1
		borderColor = Emlib.getColor(borderColor, "table") -- conversion couleur en table rgb
		if (not frame.borders) then
			----------------------------------- création bordures
			frame.borders = {}
			for i = 1, 4 do
				frame.borders[i] = frame:CreateLine(nil, "BACKGROUND", nil, 0)
				local l = frame.borders[i]
				l:SetThickness(borderWidth)
				l:SetColorTexture(borderColor[1], borderColor[2], borderColor[3], borderAlpha)
				if (i == 1) then
					l:SetStartPoint("TOPLEFT", 0, 0)
					l:SetEndPoint("TOPRIGHT", 0, 0)
				elseif (i == 2) then
					l:SetStartPoint("TOPRIGHT", 0, 0)
					l:SetEndPoint("BOTTOMRIGHT", 0, 0)
				elseif (i == 3) then
					l:SetStartPoint("BOTTOMRIGHT", 0, 0)
					l:SetEndPoint("BOTTOMLEFT", 0, 0)
				else
					l:SetStartPoint("BOTTOMLEFT", 0, 0)
					l:SetEndPoint("TOPLEFT", 0, 0)
				end
			end
		else
			----------------------------------- modification couleur et largeur bordures
			for i = 1, 4 do
				frame.borders[i]:SetThickness(borderWidth)
				frame.borders[i]:SetColorTexture(borderColor[1], borderColor[2], borderColor[3], borderAlpha)
			end
		end
	end
end

function Emlib.setColoredFrame(frame, bkColor, borderColor, borderWidth, alpha, texName)
	-- ajoute une texture avec une éventuelle bordure, au FRAME passé (non BUTTON)
	-- renvoit un pointeur vers cette texture
	-- frame.texture et frame.backdrop sont dispos
	
	---- bkColor : couleur du fond (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- borderColor : couleur de la bordure (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- alpha : de la texture (n'impacte pas la bordure)
	---- texName : nom de la texture créée ("$parent_tex" par défaut)
	--[[ exemples d'appel :
			Emlib.setColoredFrame(frame, {0.2, 0.2, 0.8}, nil, 0, 0.8) -- pas de bordure
			local theTexture = Emlib.setColoredFrame(frame, "#555555", "red", 1, 0.8) -- bordure rouge de 1 px
	--]]
	Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, texName)
end

function Emlib.setColoredButton(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
	-- ajoute une texture, et une texture highlight, avec une éventuelle bordure, au BUTTON passé
	-- renvoit un pointeur vers cette texture
	-- frame.texture et frame.backdrop sont dispos
	
	---- bkColor : couleur du fond (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- borderColor : couleur de la bordure (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- alpha : de la texture (n'impacte pas la bordure)
	---- hilitedAlphaOrColor : couleur hilited (toutes formes acceptées) OU valeur alpha (nombre)
	---- texName : nom de la texture créée ("$parent_tex" par défaut)
	--[[ exemples d'appel :
			Emlib.setColoredButton(button, {0.2, 0.2, 0.8}, nil, 0, 0.8, 0.3) -- pas de bordure et hilite par modif alpha (0.3)
			Emlib.setColoredButton(button, {0.2, 0.2, 0.8}, "red", 1, 0.8, 0.3) -- bordure rouge de 1 px
			Emlib.setColoredButton(button, "grey", nil, 0, 0.8, "yellow" -- hilite button jaune
	--]]
	Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
end

function Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
	-- .setColoredButton() ou .setColoredFrame() suivant si FRAME simple ou BUTTON
	-- frame.texture est dispo
	-- DEPENDANCE : .createBorder()
	local bkColor = bkColor or {0.2, 0.2, 0.9} -- couleur RGB du fond
	bkColor = Emlib.getColor(bkColor, "table")
	local borderColor = borderColor or {0.8, 0.8, 0.3}
	borderColor = Emlib.getColor(borderColor, "table")
	local borderWidth = tonumber(borderWidth) or 0 -- cadre éventuel
	local alpha = tonumber(alpha) or 1 -- alpha de la texture (pas de la bordure !)
	local texName = texName or (Emlib.videSiNul(frame:GetName()).."_tex") --/////
	
	local borderAlpha = 0.9 -- ///// non géré dans les paramètres de la fcn
--print("setColoredRegion() : ", texName, "---borderWidth=", borderWidth,"---bkColor=", bkColor[1], borderColor[2], borderColor[3],"---alpha=", alpha)--/////
	
	------------------------------------------------ fond (création texture RGB)
	if (not frame.texture) then frame.texture = frame:CreateTexture(texName, "BACKGROUND") end
	frame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], alpha)
	frame.texture:SetAlpha(alpha) -- répétition pour bug SetColorTexture() ?
	frame.texture:SetAllPoints()

	------------------------------------------------ bordure éventuelle
	if (borderWidth > 0) then Emlib.createBorder(frame, borderWidth, borderColor, borderAlpha) end
	
	------------------------------------------------ création hilite texture (pour bouton seulement)
	if (frame:IsObjectType("Button")) then -- secu
		if (not frame.hitexture) then frame.hitexture = frame:CreateTexture(texName.."HI", "BACKGROUND") end --/////
		local hilitedAlphaOrColor = hilitedAlphaOrColor or 0.4 -- hilite par modif alpha pour un BUTTON
		if (type(hilitedAlphaOrColor) == "number") then
			---------- l'hilite se fera par un changement d'alpha
			frame.hitexture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], hilitedAlphaOrColor)
			frame.hitexture:SetAlpha(hilitedAlphaOrColor) -- répétition pour bug SetColorTexture() ?
		else
			---------- l'hilite se fera par une nouvelle valeur RGB
			if (type(hilitedAlphaOrColor) ~= "table") then hilitedAlphaOrColor = Emlib.getColor(hilitedAlphaOrColor, "table") end
			frame.hitexture:SetColorTexture(hilitedAlphaOrColor[1], hilitedAlphaOrColor[2], hilitedAlphaOrColor[3], 0.5)
		end
		frame.hitexture:SetAllPoints()
		frame:SetHighlightTexture(frame.hitexture) -- seulement BUTTON
	end
	
	return frame.texture
end

function Emlib.setTexturedFrame(frame, texName, imagePath, imgCoordH, imgCoordV, alpha, hilitedTexOrValue)
	---- créé une TEXTURE par FICHIER IMAGE au frame passé (et renvoit un pointeur vers cette texture)
	---- texName : nom de texture (si nil, ajout de "Hi")
	---- imgCoordH et imgCoordV : tables  {h1, v1} et {v1, v2}, ou entiers si pas besoin de décalage
	---- hilitedAlphaOrRGB (seulement pour les boutons) : texture hilited (autre image ou valeur alpha)
	---- attention : le SetSize() du frame n'est pas inclus !
	--[[ exemples d'appel :
			Emlib.setTexturedFrame(myFrame, "myFrame_tex", "Interface\\AddOns\\NPCsMarkers\\stuff\\myPict", 40, 25, 0.8, "Interface\\AddOns\\NPCsMarkers\\stuff\\myPictHI") -- size frame : 40 x 25
			Emlib.setTexturedFrame(myFrame, nil, "Interface\\AddOns\\NPCsMarkers\\stuff\\myPict", {10, 40}, {0, 30}, 1, 0.3)
	--]]
	local hilitedTexOrValue = hilitedTexOrValue or 0.4
	local alpha = tonumber(alpha) or 1
	local imgCoordsTable = imgCoordsTable or {{0, 1}, {0, 1}}
	local texName = texName or (Emlib.videSiNul(frame:GetName()).."_tex")
	------------------------------------------------- texture image
	-------------- coords V : si imgCoordV est un entier : l'image est calée en 0 (coin haut)
	local imgCoordV = imgCoordV or {0, 1}
	local v1 = 0
	local v2 = 1
	if (type(imgCoordV) == "table") then
		v1 = Emlib.strToNumber(imgCoordV[1])
		v2 = Emlib.strToNumber(imgCoordV[2])
	else
		v2 = Emlib.strToNumber(imgCoordV)
	end
	-------------- coords H : si imgCoordH est un entier : l'image est calée en 0 (coin gauche)
	local imgCoordH = imgCoordH or {0, 1}
	local h1 = 0
	local h2 = 1
	if (type(imgCoordH) == "table") then
		h1 = Emlib.strToNumber(imgCoordH[1])
		h2 = Emlib.strToNumber(imgCoordH[2])
	else
		h2 = Emlib.strToNumber(imgCoordH)
	end
	-------------- calcul taille TGA nécessaire (plus petite taille pour contenir les dimensions passées)
	local tgaWidth = Emlib.getMinTgaSize(h2)
	local tgaHeight = Emlib.getMinTgaSize(v2)
--print("setTexturedFrame()----","h1=",h1,"h2=",h2,"v1=",v1,"v2=",v2,"tgaWidth=",tgaWidth,"tgaHeight=",tgaHeight)--/////
	--------------
	
	
	------------------------------------------------ fond (création texture RGB)
	if (not frame.texture) then frame.texture = frame:CreateTexture(texName, "BACKGROUND") end
	frame.texture:SetTexture(imagePath)
	frame.texture:SetAllPoints()
	frame.texture:SetTexCoord(h1/tgaWidth, h2/tgaWidth, v1/tgaHeight, v2/tgaHeight)
	frame.texture:SetAlpha(alpha)
	------------------------------------------------- hilite
	if (frame:IsObjectType("Button")) then
		---------- seuls les boutons acceptent un hilite !
		local texNameHi = nil
		if (texName ~= nil) then texNameHi = texName.."HI" end
		local hitexture = frame:CreateTexture(texNameHi, "BACKGROUND")
		
		if (type(hilitedTexOrValue) == "number") then
			---------- l'hilite se fera par un changement d'alpha
			hitexture:SetTexture(imagePath)
			hitexture:SetAlpha(hilitedTexOrValue)
		elseif (type(hilitedTexOrValue) == "string") then
			---------- l'hilite se fera par une autre image
			hitexture:SetTexture(hilitedTexOrValue)
		end
		
		hitexture:SetAllPoints()
		hitexture:SetTexCoord(h1/tgaWidth, h2/tgaWidth, v1/tgaHeight, v2/tgaHeight)
		frame:SetHighlightTexture(hitexture)
	end
	
	return frame.texture
end

function Emlib.getMinTgaSize(texSize)
	local texSize = tonumber(texSize) or 0
	local tgaSize = 0
	for i = 1, 14 do -- increment 1 par defaut
		tgaSize = math.pow(2, i)
		if (tgaSize >= texSize) then
			break
		end
	end
	return tgaSize
end

function Emlib.setFramedFrame(frame, frameTypeOrColorTable, borderColor, borderWidth, alpha)
	---- affecte une bordure par BACKDROP au frame passé
	---- frameTypeOrColorTable : "dialog" | "dlog" | "tooltip" (cadre fin) ou une table {r, g, b}
	---- borderColor : nom couleur, ou couleur hexa, ou table {r, g, b}
	---- borderWidth : seulement si non "dialog" ou "tooltip" (1 par défaut)
	--[[ exemples d'appel :
			Emlib.setFramedFrame(temp, "tooltip")
			Emlib.setFramedFrame(temp, {0.2, 0.5, 0.5}, {0.8, 0.5, 0.2}, 1, 0.8) -- bordure de 1 px
			Emlib.setFramedFrame(temp, {0.2, 0.2, 0.8}, "red", 4, 0.8) -- bordure de 4 px
	--]]

	if (not frame.SetBackdrop) then Mixin(frame, BackdropTemplateMixin) end
	
	local frameTypeOrColorTable = frameTypeOrColorTable or "tooltip"
	if (type(frameTypeOrColorTable) == "table") then
		---------------------------------- pas de design pré-défini
		------------- fond
		local borderWidth = Emlib.entierParDefaut(borderWidth, 1)
		local r = Emlib.strToNumber(frameTypeOrColorTable[1]) -- 0 si probleme
		local g = Emlib.strToNumber(frameTypeOrColorTable[2])
		local b = Emlib.strToNumber(frameTypeOrColorTable[3])
		
		frame.backdrop = { -- backdrop definition
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface/Buttons/WHITE8X8", 
			edgeSize = borderWidth,
			tile = true,
			tileSize = 16,
			insets = {left = borderWidth, right = borderWidth, top = borderWidth, bottom = borderWidth},
		}
		frame:SetBackdrop(frame.backdrop)
		local alpha = tonumber(alpha) or 1
		frame:SetBackdropColor(r, g, b, alpha)
		
		---------------------- bordure
		if (borderWidth > 0) then 
			local borderColor = borderColor or {0.8, 0.8, 0.8}
			borderColor = Emlib.getColor(borderColor, "table")
			frame:SetBackdropBorderColor(Emlib.strToNumber(borderColor[1]), Emlib.strToNumber(borderColor[2]), Emlib.strToNumber(borderColor[3]))
		end
		
	else
		---------------------------------- modèle frame pré-défini : "dialog" ou "tooltip"
		if (strlower(frameTypeOrColorTable) == "dialog" or strlower(frameTypeOrColorTable) == "dlog") then
			frame.backdrop = { -- backdrop definition
				bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
				edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
				tile = true,
				tileSize = 32,
				edgeSize = 32,
				insets = {left = 12, right = 12, top = 12, bottom = 11},
			}
		else
			frame.backdrop = { -- backdrop definition
				bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				tile = true,
				tileSize = 16,
				edgeSize = 16,
				insets = {left = 4, right = 4, top = 4, bottom = 2},
			}
		end
		frame:SetBackdrop(frame.backdrop)
	end
end

function Emlib.showBackdropsList() -- pour dev : affichage des built-in backdrops
	local tbl = {"BACKDROP_TOOLTIP_8_8_1111", "BACKDROP_TOOLTIP_8_12_1111", "BACKDROP_TOOLTIP_16_16_5555", "BACKDROP_TOOLTIP_12_12_4444", "BACKDROP_TOOLTIP_0_16", "BACKDROP_TOOLTIP_0_12_0055", "BACKDROP_TOOLTIP_0_16_5555", "BACKDROP_ACHIEVEMENTS_0_64", "BACKDROP_ARENA_32_32", "BACKDROP_DIALOG_32_32", "BACKDROP_GOLD_DIALOG_32_32", "BACKDROP_WATERMARK_DIALOG_0_16", "BACKDROP_SLIDER_8_8", "BACKDROP_PARTY_32_32", "BACKDROP_TOAST_12_12", "BACKDROP_CALLOUT_GLOW_0_1", "BACKDROP_CALLOUT_GLOW_0_20", "BACKDROP_GLUE_TOOLTIP_16_16", "BACKDROP_GLUE_TOOLTIP_0_16", "BACKDROP_MIXED_TOOLTIP_16_16", "BACKDROP_TEXT_PANEL_0_16", "", "", "", ""}
	
	local largeur, hauteur, marge = 210, 70, 15
	
	local h, v = 10, -10
	local maxH, maxV = UIParent:GetWidth(), UIParent:GetHeight()
	local frame, str
	for i, value in ipairs(tbl) do
		if (value ~= "") then
			frame = CreateFrame("Frame", "frameTest_"..i, UIParent)
			frame:SetSize(largeur, hauteur)
			frame:SetPoint("TOPLEFT", "$parent", "TOPLEFT", h, v)
			-------------- backdrop
			frame.texture = frame:CreateTexture(frame:GetName().."_tex", "BACKGROUND")
			--frame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], alpha)
			frame.texture:SetAllPoints()
			if (not frame.SetBackdrop) then Mixin(frame, BackdropTemplateMixin) end
			frame:SetBackdrop(_G[value])
			-------------- texte
			str = frame:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormalSmall")
			str:SetFont("Interface\\AddOns\\CmdLine\\stuff\\Myriad Condensed Web.ttf", 11, "NONE") --/////
			str:SetPoint("CENTER", 1, 0)
			str:SetText(tostring(value))
			str:SetJustifyH("CENTER")
			-------------- placement
			h = h + largeur + marge
			if (h + largeur > maxH) then
				h = 10
				v = v - hauteur - marge
			end
			if (math.abs(v) + hauteur > maxV) then
				print("showBackdropsList(): not enough height:", #(tbl) - i, "frames left")
				break
			end
		end
	end
end

function Emlib.setFontStyle(fontObject, fontNameOrPath, fontSize, color, outlineBoolean, alpha)
	-- fontName = "arial", ou chemin police, ou "friz" par defaut
	-- color : tout type admis : rgb, nom ou tableRGB ("yellow" par défaut)
	local alpha = alpha or 1
	local color = color or {1, 0.8, 0} -- jaune standard
	local fontSize = tonumber(fontSize) or 12
	local fontNameOrPath = fontNameOrPath or "friz"
	
	local style = "OUTLINE, MONOCHROME"
	if (not outlineBoolean) then style = "NONE" end
	
	if ((string.find(fontNameOrPath, ".ttf", 1, true) ~= nil) or (string.find(fontNameOrPath, ".TTF", 1, true) ~= nil)) then
		--------------- chemin font
		fontObject:SetFont(fontNameOrPath, fontSize, style)
	else
		--------------- nom (font built-in)
		fontNameOrPath = strlower(fontNameOrPath)
		if (fontNameOrPath == "arial") then
			fontObject:SetFont("Fonts\\ARIALN.TTF", fontSize, style)
		else
			fontObject:SetFont("Fonts\\FRIZQT__.TTF", fontSize, style) -- défaut
		end
	end
	
	local r, g, b = Emlib.getColor(color, "rgb")
	fontObject:SetTextColor(r, g, b, alpha)
end

---------------------------------------------------------------------------------------
--------------------------------------- ECHOTAGE --------------------------------------

function Emlib.getTxtColor(str, color)
	-- renvoit la chaine passée formatté avec la couleur passée (tout format de couleur accepté, "SYSTEM" par défaut)
	if (str == nil or str == "") then
		return ""
	else
		return ("|cFF"..Emlib.getColor(color, "hexa")..str.."|r")
	end
end

function Emlib.echoWindow(str, color, chatWindowName)
	-- affiche la chaine passée (nouveau nom pour rétro-compatibilité)
	-- chatWindowName : nom chat optionnel (si omis, la 1ere fenetre de chat visible et valide sera utilisée).
	-- chatWindowName : ATTENTION : si cette fenetre existe, elle sera utilisée, même si pas au 1er plan !!!
	-- color : tout format de couleur accepté, "grey" si omis
	
	local color = color or "grey"
	local r, g, b = Emlib.getColor(color, "rgb")
	------------------ recherche index (indexChatFrame) de la fenetre de chat correspondant au nom passé
	local indexChatFrame = 0
	if (chatWindowName ~= nil and chatWindowName ~= "") then
		indexChatFrame = Emlib.getIndexChatWindow(chatWindowName) -- 0 si non existe
	else
		indexChatFrame = Emlib.getIndexFistVisibleChatWindow()
	end
	------------------ affichage (dans DEFAULT si indexChatFrame == 0)
	if (indexChatFrame == 0) then indexChatFrame = DEFAULT_CHAT_FRAME:GetID() end
	_G["ChatFrame"..indexChatFrame]:AddMessage(str, r, g, b, ChatTypeInfo["SYSTEM"])
end
function Emlib.echo(chaine, color, nomChat) -- raccourci et rétro-compatibilité
	local chatWindowName = nomChat or nil
	Emlib.echoWindow(chaine, color, chatWindowName)
--[[
	local tblChat = ChatTypeInfo["SYSTEM"]
	if (DEFAULT_CHAT_FRAME) then ChatFrame1:AddMessage(chaine, tblChat["r"] , tblChat["g"], tblChat["b"]); end;
--]]
end
function Emlib.echoChat(str, color, allWindows) -- pour rétro-compatibilité
	-- affiche le message passé dans la 1ere fenetre de chat VISIBLE
	Emlib.echoWindow(str, color, nil)
end

function Emlib.getIndexChatWindow(chatWindowName) -- renvoit l'index de la fenetre de chat passée (ou 0 si n'existe pas)
	local indexChatFrame = 0
	for i = 1, NUM_CHAT_WINDOWS, 1 do
		local name, fontSize, r, g, b, alpha, shown = GetChatWindowInfo(i)
--print("name",i,name, shown)--/////
		if (name == chatWindowName) then
			indexChatFrame = i
			break
		end
	end
	return indexChatFrame
end

function Emlib.getIndexFistVisibleChatWindow() -- renvoit l'index de la 1ere fenetre de chat visible (ou 0)
	local indexChatFrame = 0
	for i = 1, NUM_CHAT_WINDOWS, 1 do
		local name, fontSize, r, g, b, alpha, shown = GetChatWindowInfo(i)
--print("visible", i,name, shown)--/////
		if (shown) then
			indexChatFrame = i
			break
		end
	end
	return indexChatFrame
end

function Emlib.echoDebug(value, commStr)
	if (commStr == nil) then
		commStr = "DEBUG "
	else
		commStr = commStr.." "
	end
	
	--if (Emlib.isTrue(value)) then
	local varType = type(value);
	if (varType == "nil") then
		Emlib.echo(commStr.."|cFFFF8040NIL")
	elseif (varType == "table") then
		Emlib.echoTable(value, commStr, false, "")
	elseif (varType == "string") then
		Emlib.echo(commStr.."STRING=|cFFFF8040"..value)
	elseif (varType == "number") then
		Emlib.echo(commStr.."NUMBER=|cFFFF8040"..value)
	elseif (varType == "boolean") then
		Emlib.echo(commStr.."BOOLEAN=|cFFFF8040"..Emlib.booleanToStr(value))
	else
		Emlib.echo(commStr.."UNKNOWN_TYPE=|cFFFF8040"..Emlib.nilSiNul(varType))
	end
end

function Emlib.echoTable(tbl, commStr, niveauUniqueBoolean, prefixeStr, nivIndent)
	-- echo recursif de table (pour debug)
	if (commStr == nil) then commStr = "DEBUG TABLE"; end;
	if (tbl == nil) then
		Emlib.echo(commStr.."|cFFEDDDC0---NIL");
	elseif next(tbl) == nil then -- attention : #tbl renvoit toujours 0
		Emlib.echo(commStr.."|cFFEDDDC0---EMPTY");
	else
		if (niveauUniqueBoolean == nil) then niveauUniqueBoolean = false; end;
		if (prefixeStr == nil) then prefixeStr = ""; end;
		if (nivIndent == nil) then
			nivIndent = 0;
		else
			nivIndent = Emlib.strToNumber(nivIndent); -- fcn perso
		end;
		
		if (nivIndent == 0) then Emlib.echo("|cFFEDDDC0---"..commStr); end;
		for key, value in pairs(tbl) do
			if (type(value) == "table") then
				if (niveauUniqueBoolean) then
					Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0".."-----TABLE");
				else
					Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0");
					local indentStr = "";
					for i = 0,nivIndent,1 do
						indentStr = indentStr.."   ";
					end;
					Emlib.echoTable(value, commStr, niveauUniqueBoolean, prefixeStr..indentStr, nivIndent + 1);
				end;
			else
				Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0"..tostring(value).."---");
			end;
		end;
	end;
end